# Generated File
from __future__ import annotations

import dataclasses
import struct
import typing
import typing_extensions

from retro_data_structures import json_util
from retro_data_structures.game_check import Game
from retro_data_structures.properties.base_property import BaseProperty
from retro_data_structures.properties.field_reflection import FieldReflection
from retro_data_structures.properties.dkc_returns.archetypes.PlayerAttachment import PlayerAttachment

if typing.TYPE_CHECKING:
    class PlayerAttachmentsDataJson(typing_extensions.TypedDict):
        player_attachment01: json_util.JsonObject
        player_attachment02: json_util.JsonObject
        player_attachment03: json_util.JsonObject
    

@dataclasses.dataclass()
class PlayerAttachmentsData(BaseProperty):
    player_attachment01: PlayerAttachment = dataclasses.field(default_factory=PlayerAttachment, metadata={
        'reflection': FieldReflection[PlayerAttachment](
            PlayerAttachment, id=0x4d2ff46b, original_name='PlayerAttachment01', from_json=PlayerAttachment.from_json, to_json=PlayerAttachment.to_json
        ),
    })
    player_attachment02: PlayerAttachment = dataclasses.field(default_factory=PlayerAttachment, metadata={
        'reflection': FieldReflection[PlayerAttachment](
            PlayerAttachment, id=0x1eb5afef, original_name='PlayerAttachment02', from_json=PlayerAttachment.from_json, to_json=PlayerAttachment.to_json
        ),
    })
    player_attachment03: PlayerAttachment = dataclasses.field(default_factory=PlayerAttachment, metadata={
        'reflection': FieldReflection[PlayerAttachment](
            PlayerAttachment, id=0x991364ac, original_name='PlayerAttachment03', from_json=PlayerAttachment.from_json, to_json=PlayerAttachment.to_json
        ),
    })

    @classmethod
    def game(cls) -> Game:
        return Game.DKC_RETURNS

    @classmethod
    def from_stream(cls, data: typing.BinaryIO, size: int | None = None, default_override: dict | None = None) -> typing_extensions.Self:
        property_count = struct.unpack(">H", data.read(2))[0]
        if (result := cls._fast_decode(data, property_count)) is not None:
            return result

        present_fields = default_override or {}
        for _ in range(property_count):
            property_id, property_size = struct.unpack(">LH", data.read(6))
            start = data.tell()
            try:
                property_name, decoder = _property_decoder[property_id]
                present_fields[property_name] = decoder(data, property_size)
            except KeyError:
                raise RuntimeError(f"Unknown property: 0x{property_id:08x}")
            assert data.tell() - start == property_size

        return cls(**present_fields)

    @classmethod
    def _fast_decode(cls, data: typing.BinaryIO, property_count: int) -> typing_extensions.Self | None:
        if property_count != 3:
            return None
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x4d2ff46b
        player_attachment01 = PlayerAttachment.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x1eb5afef
        player_attachment02 = PlayerAttachment.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x991364ac
        player_attachment03 = PlayerAttachment.from_stream(data, property_size)
    
        return cls(player_attachment01, player_attachment02, player_attachment03)

    def to_stream(self, data: typing.BinaryIO, default_override: dict | None = None) -> None:
        default_override = default_override or {}
        data.write(b'\x00\x03')  # 3 properties

        data.write(b'M/\xf4k')  # 0x4d2ff46b
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.player_attachment01.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x1e\xb5\xaf\xef')  # 0x1eb5afef
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.player_attachment02.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x99\x13d\xac')  # 0x991364ac
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.player_attachment03.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

    @classmethod
    def from_json(cls, data: json_util.JsonValue) -> typing_extensions.Self:
        json_data = typing.cast("PlayerAttachmentsDataJson", data)
        return cls(
            player_attachment01=PlayerAttachment.from_json(json_data['player_attachment01']),
            player_attachment02=PlayerAttachment.from_json(json_data['player_attachment02']),
            player_attachment03=PlayerAttachment.from_json(json_data['player_attachment03']),
        )

    def to_json(self) -> json_util.JsonObject:
        return {
            'player_attachment01': self.player_attachment01.to_json(),
            'player_attachment02': self.player_attachment02.to_json(),
            'player_attachment03': self.player_attachment03.to_json(),
        }


_property_decoder: typing.Dict[int, typing.Tuple[str, typing.Callable[[typing.BinaryIO, int], typing.Any]]] = {
    0x4d2ff46b: ('player_attachment01', PlayerAttachment.from_stream),
    0x1eb5afef: ('player_attachment02', PlayerAttachment.from_stream),
    0x991364ac: ('player_attachment03', PlayerAttachment.from_stream),
}
