# Generated File
from __future__ import annotations

import dataclasses
import struct
import typing
import typing_extensions

from retro_data_structures import json_util
from retro_data_structures.game_check import Game
from retro_data_structures.properties.base_property import BaseProperty
from retro_data_structures.properties.field_reflection import FieldReflection
from retro_data_structures.properties.echoes.archetypes.WeaponVulnerability import WeaponVulnerability

if typing.TYPE_CHECKING:
    from retro_data_structures.asset_manager import AssetManager
    from retro_data_structures.base_resource import Dependency

    class DamageVulnerabilityJson(typing_extensions.TypedDict):
        power: json_util.JsonObject
        dark: json_util.JsonObject
        light: json_util.JsonObject
        annihilator: json_util.JsonObject
        boost_ball: json_util.JsonObject
        cannon_ball: json_util.JsonObject
        screw_attack: json_util.JsonObject
        bomb: json_util.JsonObject
        power_bomb: json_util.JsonObject
        missile: json_util.JsonObject
        phazon: json_util.JsonObject
        ai: json_util.JsonObject
        poison_water: json_util.JsonObject
        dark_water: json_util.JsonObject
        lava: json_util.JsonObject
        area_damage_hot: json_util.JsonObject
        area_damage_cold: json_util.JsonObject
        area_damage_dark: json_util.JsonObject
        area_damage_light: json_util.JsonObject
        power_charge: json_util.JsonObject
        entangler: json_util.JsonObject
        light_blast: json_util.JsonObject
        sonic_boom: json_util.JsonObject
        super_missle: json_util.JsonObject
        black_hole: json_util.JsonObject
        sunburst: json_util.JsonObject
        imploder: json_util.JsonObject
        weapon_vulnerability: json_util.JsonObject
        normal_safe_zone: json_util.JsonObject
    

@dataclasses.dataclass()
class DamageVulnerability(BaseProperty):
    power: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xac8bb2a7, original_name='Power', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    dark: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xb19b6d6c, original_name='Dark', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    light: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x002444c6, original_name='Light', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    annihilator: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xe6bacde5, original_name='Annihilator', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    boost_ball: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xd99c0400, original_name='BoostBall', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    cannon_ball: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xc70d8b8b, original_name='CannonBall', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    screw_attack: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x866f91bf, original_name='ScrewAttack', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    bomb: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x68ae13a0, original_name='Bomb', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    power_bomb: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xf0b2f4cf, original_name='PowerBomb', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    missile: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x00efe8cb, original_name='Missile', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    phazon: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xbb70093f, original_name='Phazon', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    ai: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xbfac229f, original_name='Ai', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    poison_water: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x50dde891, original_name='PoisonWater', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    dark_water: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x97b5c68b, original_name='DarkWater', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    lava: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xf4ce8acf, original_name='Lava', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    area_damage_hot: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x1d52588d, original_name='AreaDamageHot', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    area_damage_cold: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x64ddd543, original_name='AreaDamageCold', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    area_damage_dark: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x3d625f10, original_name='AreaDamageDark', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    area_damage_light: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x591b80e3, original_name='AreaDamageLight', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    power_charge: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xa442b4a3, original_name='PowerCharge', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    entangler: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x2a0f0524, original_name='Entangler', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    light_blast: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x949e3c86, original_name='LightBlast', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    sonic_boom: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x5ba991b1, original_name='SonicBoom', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    super_missle: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x6924b8c1, original_name='SuperMissle', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    black_hole: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x1ab78bef, original_name='BlackHole', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    sunburst: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0xfcdcb7d4, original_name='Sunburst', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    imploder: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x311fb061, original_name='Imploder', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    weapon_vulnerability: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x89d25df4, original_name='WeaponVulnerability', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })
    normal_safe_zone: WeaponVulnerability = dataclasses.field(default_factory=WeaponVulnerability, metadata={
        'reflection': FieldReflection[WeaponVulnerability](
            WeaponVulnerability, id=0x3356d37e, original_name='NormalSafeZone', from_json=WeaponVulnerability.from_json, to_json=WeaponVulnerability.to_json
        ),
    })

    @classmethod
    def game(cls) -> Game:
        return Game.ECHOES

    @classmethod
    def from_stream(cls, data: typing.BinaryIO, size: int | None = None, default_override: dict | None = None) -> typing_extensions.Self:
        property_count = struct.unpack(">H", data.read(2))[0]
        if (result := cls._fast_decode(data, property_count)) is not None:
            return result

        present_fields = default_override or {}
        for _ in range(property_count):
            property_id, property_size = struct.unpack(">LH", data.read(6))
            start = data.tell()
            try:
                property_name, decoder = _property_decoder[property_id]
                present_fields[property_name] = decoder(data, property_size)
            except KeyError:
                raise RuntimeError(f"Unknown property: 0x{property_id:08x}")
            assert data.tell() - start == property_size

        return cls(**present_fields)

    @classmethod
    def _fast_decode(cls, data: typing.BinaryIO, property_count: int) -> typing_extensions.Self | None:
        if property_count != 29:
            return None
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xac8bb2a7
        power = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xb19b6d6c
        dark = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x002444c6
        light = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xe6bacde5
        annihilator = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xd99c0400
        boost_ball = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xc70d8b8b
        cannon_ball = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x866f91bf
        screw_attack = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x68ae13a0
        bomb = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xf0b2f4cf
        power_bomb = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x00efe8cb
        missile = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xbb70093f
        phazon = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xbfac229f
        ai = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x50dde891
        poison_water = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x97b5c68b
        dark_water = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xf4ce8acf
        lava = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x1d52588d
        area_damage_hot = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x64ddd543
        area_damage_cold = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x3d625f10
        area_damage_dark = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x591b80e3
        area_damage_light = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xa442b4a3
        power_charge = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x2a0f0524
        entangler = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x949e3c86
        light_blast = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x5ba991b1
        sonic_boom = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x6924b8c1
        super_missle = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x1ab78bef
        black_hole = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0xfcdcb7d4
        sunburst = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x311fb061
        imploder = WeaponVulnerability.from_stream(data, property_size)
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x89d25df4
        weapon_vulnerability = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        property_id, property_size = struct.unpack(">LH", data.read(6))
        assert property_id == 0x3356d37e
        normal_safe_zone = WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})
    
        return cls(power, dark, light, annihilator, boost_ball, cannon_ball, screw_attack, bomb, power_bomb, missile, phazon, ai, poison_water, dark_water, lava, area_damage_hot, area_damage_cold, area_damage_dark, area_damage_light, power_charge, entangler, light_blast, sonic_boom, super_missle, black_hole, sunburst, imploder, weapon_vulnerability, normal_safe_zone)

    def to_stream(self, data: typing.BinaryIO, default_override: dict | None = None) -> None:
        default_override = default_override or {}
        data.write(b'\x00\x1d')  # 29 properties

        data.write(b'\xac\x8b\xb2\xa7')  # 0xac8bb2a7
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.power.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xb1\x9bml')  # 0xb19b6d6c
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.dark.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x00$D\xc6')  # 0x2444c6
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.light.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xe6\xba\xcd\xe5')  # 0xe6bacde5
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.annihilator.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xd9\x9c\x04\x00')  # 0xd99c0400
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.boost_ball.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xc7\r\x8b\x8b')  # 0xc70d8b8b
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.cannon_ball.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x86o\x91\xbf')  # 0x866f91bf
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.screw_attack.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'h\xae\x13\xa0')  # 0x68ae13a0
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.bomb.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xf0\xb2\xf4\xcf')  # 0xf0b2f4cf
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.power_bomb.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x00\xef\xe8\xcb')  # 0xefe8cb
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.missile.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xbbp\t?')  # 0xbb70093f
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.phazon.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xbf\xac"\x9f')  # 0xbfac229f
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.ai.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'P\xdd\xe8\x91')  # 0x50dde891
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.poison_water.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x97\xb5\xc6\x8b')  # 0x97b5c68b
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.dark_water.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xf4\xce\x8a\xcf')  # 0xf4ce8acf
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.lava.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x1dRX\x8d')  # 0x1d52588d
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.area_damage_hot.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'd\xdd\xd5C')  # 0x64ddd543
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.area_damage_cold.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'=b_\x10')  # 0x3d625f10
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.area_damage_dark.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'Y\x1b\x80\xe3')  # 0x591b80e3
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.area_damage_light.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xa4B\xb4\xa3')  # 0xa442b4a3
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.power_charge.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'*\x0f\x05$')  # 0x2a0f0524
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.entangler.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x94\x9e<\x86')  # 0x949e3c86
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.light_blast.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'[\xa9\x91\xb1')  # 0x5ba991b1
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.sonic_boom.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'i$\xb8\xc1')  # 0x6924b8c1
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.super_missle.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x1a\xb7\x8b\xef')  # 0x1ab78bef
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.black_hole.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\xfc\xdc\xb7\xd4')  # 0xfcdcb7d4
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.sunburst.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'1\x1f\xb0a')  # 0x311fb061
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.imploder.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'\x89\xd2]\xf4')  # 0x89d25df4
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.weapon_vulnerability.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

        data.write(b'3V\xd3~')  # 0x3356d37e
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.normal_safe_zone.to_stream(data, default_override={'damage_multiplier': 0.0})
        after = data.tell()
        data.seek(before)
        data.write(struct.pack(">H", after - before - 2))
        data.seek(after)

    @classmethod
    def from_json(cls, data: json_util.JsonValue) -> typing_extensions.Self:
        json_data = typing.cast("DamageVulnerabilityJson", data)
        return cls(
            power=WeaponVulnerability.from_json(json_data['power']),
            dark=WeaponVulnerability.from_json(json_data['dark']),
            light=WeaponVulnerability.from_json(json_data['light']),
            annihilator=WeaponVulnerability.from_json(json_data['annihilator']),
            boost_ball=WeaponVulnerability.from_json(json_data['boost_ball']),
            cannon_ball=WeaponVulnerability.from_json(json_data['cannon_ball']),
            screw_attack=WeaponVulnerability.from_json(json_data['screw_attack']),
            bomb=WeaponVulnerability.from_json(json_data['bomb']),
            power_bomb=WeaponVulnerability.from_json(json_data['power_bomb']),
            missile=WeaponVulnerability.from_json(json_data['missile']),
            phazon=WeaponVulnerability.from_json(json_data['phazon']),
            ai=WeaponVulnerability.from_json(json_data['ai']),
            poison_water=WeaponVulnerability.from_json(json_data['poison_water']),
            dark_water=WeaponVulnerability.from_json(json_data['dark_water']),
            lava=WeaponVulnerability.from_json(json_data['lava']),
            area_damage_hot=WeaponVulnerability.from_json(json_data['area_damage_hot']),
            area_damage_cold=WeaponVulnerability.from_json(json_data['area_damage_cold']),
            area_damage_dark=WeaponVulnerability.from_json(json_data['area_damage_dark']),
            area_damage_light=WeaponVulnerability.from_json(json_data['area_damage_light']),
            power_charge=WeaponVulnerability.from_json(json_data['power_charge']),
            entangler=WeaponVulnerability.from_json(json_data['entangler']),
            light_blast=WeaponVulnerability.from_json(json_data['light_blast']),
            sonic_boom=WeaponVulnerability.from_json(json_data['sonic_boom']),
            super_missle=WeaponVulnerability.from_json(json_data['super_missle']),
            black_hole=WeaponVulnerability.from_json(json_data['black_hole']),
            sunburst=WeaponVulnerability.from_json(json_data['sunburst']),
            imploder=WeaponVulnerability.from_json(json_data['imploder']),
            weapon_vulnerability=WeaponVulnerability.from_json(json_data['weapon_vulnerability']),
            normal_safe_zone=WeaponVulnerability.from_json(json_data['normal_safe_zone']),
        )

    def to_json(self) -> json_util.JsonObject:
        return {
            'power': self.power.to_json(),
            'dark': self.dark.to_json(),
            'light': self.light.to_json(),
            'annihilator': self.annihilator.to_json(),
            'boost_ball': self.boost_ball.to_json(),
            'cannon_ball': self.cannon_ball.to_json(),
            'screw_attack': self.screw_attack.to_json(),
            'bomb': self.bomb.to_json(),
            'power_bomb': self.power_bomb.to_json(),
            'missile': self.missile.to_json(),
            'phazon': self.phazon.to_json(),
            'ai': self.ai.to_json(),
            'poison_water': self.poison_water.to_json(),
            'dark_water': self.dark_water.to_json(),
            'lava': self.lava.to_json(),
            'area_damage_hot': self.area_damage_hot.to_json(),
            'area_damage_cold': self.area_damage_cold.to_json(),
            'area_damage_dark': self.area_damage_dark.to_json(),
            'area_damage_light': self.area_damage_light.to_json(),
            'power_charge': self.power_charge.to_json(),
            'entangler': self.entangler.to_json(),
            'light_blast': self.light_blast.to_json(),
            'sonic_boom': self.sonic_boom.to_json(),
            'super_missle': self.super_missle.to_json(),
            'black_hole': self.black_hole.to_json(),
            'sunburst': self.sunburst.to_json(),
            'imploder': self.imploder.to_json(),
            'weapon_vulnerability': self.weapon_vulnerability.to_json(),
            'normal_safe_zone': self.normal_safe_zone.to_json(),
        }

    def dependencies_for(self, asset_manager: AssetManager) -> typing.Iterator[Dependency]:
        for method, field_name, field_type in [
            (self.power.dependencies_for, "power", "WeaponVulnerability"),
            (self.dark.dependencies_for, "dark", "WeaponVulnerability"),
            (self.light.dependencies_for, "light", "WeaponVulnerability"),
            (self.annihilator.dependencies_for, "annihilator", "WeaponVulnerability"),
            (self.boost_ball.dependencies_for, "boost_ball", "WeaponVulnerability"),
            (self.cannon_ball.dependencies_for, "cannon_ball", "WeaponVulnerability"),
            (self.screw_attack.dependencies_for, "screw_attack", "WeaponVulnerability"),
            (self.bomb.dependencies_for, "bomb", "WeaponVulnerability"),
            (self.power_bomb.dependencies_for, "power_bomb", "WeaponVulnerability"),
            (self.missile.dependencies_for, "missile", "WeaponVulnerability"),
            (self.phazon.dependencies_for, "phazon", "WeaponVulnerability"),
            (self.ai.dependencies_for, "ai", "WeaponVulnerability"),
            (self.poison_water.dependencies_for, "poison_water", "WeaponVulnerability"),
            (self.dark_water.dependencies_for, "dark_water", "WeaponVulnerability"),
            (self.lava.dependencies_for, "lava", "WeaponVulnerability"),
            (self.area_damage_hot.dependencies_for, "area_damage_hot", "WeaponVulnerability"),
            (self.area_damage_cold.dependencies_for, "area_damage_cold", "WeaponVulnerability"),
            (self.area_damage_dark.dependencies_for, "area_damage_dark", "WeaponVulnerability"),
            (self.area_damage_light.dependencies_for, "area_damage_light", "WeaponVulnerability"),
            (self.power_charge.dependencies_for, "power_charge", "WeaponVulnerability"),
            (self.entangler.dependencies_for, "entangler", "WeaponVulnerability"),
            (self.light_blast.dependencies_for, "light_blast", "WeaponVulnerability"),
            (self.sonic_boom.dependencies_for, "sonic_boom", "WeaponVulnerability"),
            (self.super_missle.dependencies_for, "super_missle", "WeaponVulnerability"),
            (self.black_hole.dependencies_for, "black_hole", "WeaponVulnerability"),
            (self.sunburst.dependencies_for, "sunburst", "WeaponVulnerability"),
            (self.imploder.dependencies_for, "imploder", "WeaponVulnerability"),
            (self.weapon_vulnerability.dependencies_for, "weapon_vulnerability", "WeaponVulnerability"),
            (self.normal_safe_zone.dependencies_for, "normal_safe_zone", "WeaponVulnerability"),
        ]:
            try:
                yield from method(asset_manager)
            except Exception as e:
                raise Exception(
                    f"Error finding dependencies for DamageVulnerability.{field_name} ({field_type}): {e}"
                )


def _decode_dark(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_light(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_annihilator(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_cannon_ball(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_ai(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_poison_water(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_dark_water(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_lava(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_area_damage_hot(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_area_damage_cold(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_area_damage_dark(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_area_damage_light(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_weapon_vulnerability(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


def _decode_normal_safe_zone(data: typing.BinaryIO, property_size: int):
    return WeaponVulnerability.from_stream(data, property_size, default_override={'damage_multiplier': 0.0})


_property_decoder: typing.Dict[int, typing.Tuple[str, typing.Callable[[typing.BinaryIO, int], typing.Any]]] = {
    0xac8bb2a7: ('power', WeaponVulnerability.from_stream),
    0xb19b6d6c: ('dark', _decode_dark),
    0x2444c6: ('light', _decode_light),
    0xe6bacde5: ('annihilator', _decode_annihilator),
    0xd99c0400: ('boost_ball', WeaponVulnerability.from_stream),
    0xc70d8b8b: ('cannon_ball', _decode_cannon_ball),
    0x866f91bf: ('screw_attack', WeaponVulnerability.from_stream),
    0x68ae13a0: ('bomb', WeaponVulnerability.from_stream),
    0xf0b2f4cf: ('power_bomb', WeaponVulnerability.from_stream),
    0xefe8cb: ('missile', WeaponVulnerability.from_stream),
    0xbb70093f: ('phazon', WeaponVulnerability.from_stream),
    0xbfac229f: ('ai', _decode_ai),
    0x50dde891: ('poison_water', _decode_poison_water),
    0x97b5c68b: ('dark_water', _decode_dark_water),
    0xf4ce8acf: ('lava', _decode_lava),
    0x1d52588d: ('area_damage_hot', _decode_area_damage_hot),
    0x64ddd543: ('area_damage_cold', _decode_area_damage_cold),
    0x3d625f10: ('area_damage_dark', _decode_area_damage_dark),
    0x591b80e3: ('area_damage_light', _decode_area_damage_light),
    0xa442b4a3: ('power_charge', WeaponVulnerability.from_stream),
    0x2a0f0524: ('entangler', WeaponVulnerability.from_stream),
    0x949e3c86: ('light_blast', WeaponVulnerability.from_stream),
    0x5ba991b1: ('sonic_boom', WeaponVulnerability.from_stream),
    0x6924b8c1: ('super_missle', WeaponVulnerability.from_stream),
    0x1ab78bef: ('black_hole', WeaponVulnerability.from_stream),
    0xfcdcb7d4: ('sunburst', WeaponVulnerability.from_stream),
    0x311fb061: ('imploder', WeaponVulnerability.from_stream),
    0x89d25df4: ('weapon_vulnerability', _decode_weapon_vulnerability),
    0x3356d37e: ('normal_safe_zone', _decode_normal_safe_zone),
}
